#include <qthing>

#include "esp_log.h"
#include "driver/gpio.h"

#include "freertos/FreeRTOS.h"
#include "freertos/task.h"


#include "CyanLight.hpp"


// ### LIBS FOR TESTING ###
#include <cstdlib>
#include "SpiderLib/SNTP.hpp"
#include "SiliconTorch/CyanBusCRC.hpp"
#include "SiliconTorch/CyanBusTOUT.hpp"
// ###     END LIBS     ###



qthing::Config cfg;

CyanLight::CyanLightControl* ctrl;

void device_main() {

  //SpiderLib::SNTP& ntp = SpiderLib::SNTP::instance();

  // ntp.registerTimeSyncHandler([](){
  //   ESP_LOGE("EVENT…", "…HANDLER()!");
  // });

  cfg.apply();

  return;

  // Needed for packet parsing, animation rendering and stuff
  qthing::power_managment_max_power();

  uint8_t L = 9;
  uint8_t* buffer = new uint8_t[L+1];
  std::memcpy(buffer, "fxk8y", 5);
  buffer[L-4] = 0x84;
  buffer[L-3] = 0xF1;
  buffer[L-2] = 0xEF;
  buffer[L-1] = 0x44;
  buffer[L] = 0x00;

  ESP_LOGW("CheckCRC", "CRC of str[ %s ] is crc[ %s ]", buffer, SiliconTorch::Impl::checkCRC(buffer, L) ? "true" : "false");

  return;

  SiliconTorch::CyanBusTOUT::CyanBus cyanBus(13, 14, 12, 15);  // Pinout of CyanStripe

  // TODO: ???


  cfg.apply();

  return;

  ctrl = new CyanLight::CyanLightControl(1);
  ctrl->addChannel(26);
  ctrl->addChannel(25);
  
  ctrl->setFrqRes(100, 19);


  for (uint8_t i = 0; i < 100; i++) {

    bool _f = i % 2 == 0;

    ctrl->setPWM(0,  _f      * 1.0f);
    ctrl->setPWM(2, (_f ^ 1) * 1.0f);

    vTaskDelay(50 / portTICK_PERIOD_MS);
  }


  ctrl->setPWM(0, 1.0f);
  ctrl->setPWM(1, 1.0f);
  ctrl->setPWM(2, 1.0f);


  qthing::enable_wifi();
  return;



  auto delay = 10 / portTICK_PERIOD_MS;
  float limit = 50.0f;

  while (true) {
    for (uint8_t i = 0; i < limit; i++) {
      float pwm = i / limit;
      ctrl->setPWM(0, pwm*pwm);
      vTaskDelay(delay);
    }

    for (uint8_t i = 0; i < limit; i++) {
      float pwm = i / limit;
      ctrl->setPWM(0, 1.0f - pwm*pwm);
      vTaskDelay(delay);
    }
  }
}
